library(gnlm)

data <- read.table("aids.dat",skip=5,head=T)
attach(data)
y <- c(Month1,Month2,Month3)
wt <- y>0
yy <- cbind(ifelse(y>0,y,1),c(C1,C2,C3))
y1 <- c(Month2,Month3)
y0 <- c(Month1,Month2)
ly0 <- log(ifelse(y0,y0,1))
wt1 <- y1>0&y0>0
yy1 <- cbind(ifelse(y1>0,y1,1),c(C2,C3))
treat <- as.factor(Treatment)

mu <- function(p,linear) exp(linear)
gnlr(yy,"Weibull",pmu=16,psh=0.4,mu=~1,wt=wt)
gnlr(yy,"Weibull",pmu=c(2.75,0,0),psh=0.4,mu=mu,linear=~rep(treat,3),wt=wt)

gnlr(yy1,"Weibull",pmu=16,psh=0.4,mu=~1,wt=wt1)
gnlr(yy1,"Weibull",pmu=c(2.75,0,0),psh=0.4,mu=mu,linear=~rep(treat,2),wt=wt1)
gnlr(yy1,"Weibull",pmu=c(2.6,0.4,0.1,0),psh=0.4,mu=mu,wt=wt1,
	linear=~rep(treat,2)+y0)
gnlr(yy1,"Weibull",pmu=c(2.6,0.4,0.1,0),psh=0.4,mu=mu,wt=wt1,
	linear=~rep(treat,2)+ly0)
