library(gnlm)
library(event)
library(repeated)

surv <- read.surv("mammary.dat",skip=11)
treat <- c(rep(0,23),rep(1,25))
resp <- restovec(surv[[1]],cens=surv[[2]])

print(ze <- kalsurv(resp,pinit=0.7,preg=4,cens=cens,dep="frailty"))
print(zet <- kalsurv(resp,ccov=treat,pinit=0.7,preg=c(4,1),cens=cens,
	dep="frailty"))
print(zetb <- kalsurv(resp,ccov=treat,pinit=0.7,preg=c(4,1),cens=cens,
	pbirth=0,dep="frailty"))
print(zw <- kalsurv(resp,pinit=0.7,preg=4,psh=1,cens=cens,
	intensity="Weibull",dep="frailty"))
print(zwb <- kalsurv(resp,pinit=0.7,preg=4,psh=1,cens=cens,
	intensity="Weibull",dep="frailty",pbirth=-1))
print(zwt <- kalsurv(resp,ccov=treat,pinit=0.7,preg=c(4,1),psh=1,
	cens=cens,intensity="Weibull",dep="frailty"))
print(zwtb <- kalsurv(resp,ccov=treat,pinit=0.1,preg=c(4,1),psh=1,
	cens=cens,intensity="Weibull",pbirth=0,dep="frailty"))
print(zg <- kalsurv(resp,pinit=0.26,preg=4,psh=1,cens=cens,
	intensity="gamma",dep="frailty",stepmax=0.1))
print(zgb <- kalsurv(resp,pinit=0.7,preg=4,psh=1,cens=cens,intensity="gamma",
	dep="frailty",pbirth=-1))
print(zgt <- kalsurv(resp,ccov=treat,pinit=0.5,preg=c(4,-0.5),psh=1,
	cens=cens,intensity="gamma",dep="frailty"))
print(zgtb <- kalsurv(resp,ccov=treat,pinit=0.05,preg=c(4.3,-0.2),psh=1,
	cens=cens,intensity="gamma",pbirth=-0.7,dep="frailty"))

print(zei <- kalsurv(resp,pinit=0.1,preg=4,cens=cens,dep="independence"))
print(zee <- kalsurv(resp,pinit=0.1,pdep=0.5,preg=4,cens=cens,
	dep="serial",upd="event"))
print(zem <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,cens=cens,
	dep="serial",upd="Markov"))
print(zec <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,cens=cens,
	dep="serial",upd="count"))
print(zeh <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,cens=cens,
	dep="serial",upd="cumulated"))
print(zel <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,cens=cens,
	dep="serial",upd="kalman"))

print(zeit <- kalsurv(resp,ccov=treat,pinit=0.7,preg=c(4,1),cens=cens,
	dep="independence"))
print(zeitb <- kalsurv(resp,ccov=treat,pinit=0.7,preg=c(4,1),cens=cens,
	dep="independence",pbirth=0))
print(zeet <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="event"))
print(zeetb <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="event",pbirth=0))
print(zemt <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="Markov"))
print(zemtb <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="Markov",pbirth=-1))
print(zect <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="count"))
print(zeht <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="cumulated"))
print(zekt <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,preg=c(4,1),
	cens=cens,dep="serial",upd="kalman"))

print(zwi <- kalsurv(resp,pinit=0.35,preg=3.5,psh=1.07,cens=cens,
	intensity="Weibull",dep="independence",stepmax=0.1))
print(zwib <- kalsurv(resp,pinit=0.1,preg=4,psh=1.3,cens=cens,
	intensity="Weibull",dep="independence",pbirth=-0.2))
#print(zwe <- kalsurv(resp,pinit=2.5,pdep=0.9,preg=4,psh=1.3,cens=cens,
#	intensity="Weibull",dep="serial",upd="event",print.level=2))
print(zwm <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,psh=1.4,cens=cens,
	intensity="Weibull",dep="serial",upd="Markov"))
print(zwmb <- kalsurv(resp,pinit=0.7,pdep=0.1,preg=4,psh=2.6,cens=cens,
	intensity="Weibull",dep="serial",upd="Markov",pbirth=-1))
print(zwc <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,psh=1,cens=cens,
	intensity="Weibull",dep="serial",upd="count"))
print(zwh <- kalsurv(resp,pinit=0.7,pdep=0.9,preg=4,psh=1,cens=cens,
	intensity="Weibull",dep="serial",upd="cumulated"))
print(zwk <- kalsurv(resp,pinit=0.7,pdep=0.1,preg=4,psh=1,cens=cens,
	intensity="Weibull",dep="serial",upd="kalman"))

if(interactive()){
postscript("mammary2.eps",height=5)
par(mfrow=c(1,2),font.main=1)
plot(0,0,ylim=c(0,100),xlim=c(60,190),type="n",xlab="Total days elapsed",
	ylab="Days between tumours",main="Retinoid")
plot(iprofile(zwitb),nind=7,add=T,pch=0,lty=1)
plot(iprofile(zwitb),nind=10,add=T,pch=1,lty=2)
plot(iprofile(zwitb),nind=21,add=T,pch=2,lty=3)
plot(0,0,ylim=c(0,100),xlim=c(60,190),type="n",xlab="Total days elapsed",
	ylab="",main="Control")
plot(iprofile(zwitb),nind=26,add=T,pch=0,lty=1)
plot(iprofile(zwitb),nind=28,add=T,pch=1,lty=2)
plot(iprofile(zwitb),nind=34,add=T,pch=2,lty=3)
}

print(zwit <- kalsurv(resp,ccov=treat,pinit=0.29,psh=1.09,preg=c(4,-0.8),
	cens=cens,dep="independence",intensity="Weibull",stepmax=0.1))
print(zwitb <- kalsurv(resp,ccov=treat,pinit=0.7,psh=2,preg=c(4,-0.2),
	cens=cens,dep="independence",intensity="Weibull",pbirth=-1))
#print(zwet <- kalsurv(resp,ccov=treat,pinit=0.1,pdep=0.5,psh=1,
#	preg=c(4,-0.8),cens=cens,intensity="Weibull",dep="serial",upd="event"))
print(zwetb <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.2,psh=1.3,
	preg=c(4,1),cens=cens,intensity="Weibull",dep="serial",upd="event",
	pbirth=0,stepmax=15))
print(zwmt <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.9,psh=1.3,
	preg=c(4,0.3),cens=cens,intensity="Weibull",dep="serial",upd="Markov"))
print(zwmtb <- kalsurv(resp,ccov=treat,pinit=1,pdep=0.9,psh=1.4,
	preg=c(4,-0.7),cens=cens,intensity="Weibull",dep="serial",upd="Markov",
	pbirth=-1))
print(zwct <- kalsurv(resp,ccov=treat,pinit=0.1,pdep=0.9,psh=1,
	preg=c(4,-1),cens=cens,intensity="Weibull",dep="serial",upd="count"))
print(zwht <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,psh=0.5,
	preg=c(4,1),cens=cens,intensity="Weibull",dep="serial",
	upd="cumulated"))
print(zwkt <- kalsurv(resp,ccov=treat,pinit=0.7,pdep=0.5,psh=0.5,
	preg=c(4,1),cens=cens,intensity="Weibull",dep="serial",upd="kalman"))

print(zgi <- kalsurv(resp,pinit=1,preg=2,psh=2.15,cens=cens,
	intensity="gamma",dep="independence"))
print(zgib <- kalsurv(resp,pinit=1.7,preg=4,psh=2.65,cens=cens,
	intensity="gamma",dep="independence",pbirth=0))
print(zgit <- kalsurv(resp,ccov=treat,pinit=2,psh=2,
	preg=c(4,0),cens=cens,intensity="gamma",dep="independence"))
print(zgitb <- kalsurv(resp,ccov=treat,pinit=2,psh=2,
	preg=c(4,0.8),pbirth=0,cens=cens,intensity="gamma",dep="independence"))
print(zge <- kalsurv(resp,pinit=0.7,pdep=0.7,preg=4,psh=2,cens=cens,
	intensity="gamma",dep="serial",upd="event"))
print(zget <- kalsurv(resp,ccov=treat,pinit=0.5,pdep=0.5,psh=1,preg=c(4,1.5),
	cens=cens,intensity="gamma",dep="serial",upd="event"))
print(zgm <- kalsurv(resp,pinit=1,pdep=0.7,preg=2,psh=2.5,cens=cens,
	intensity="gamma",dep="serial",upd="Markov"))
print(zgmb <- kalsurv(resp,pinit=1,pdep=0.7,preg=3,psh=2.5,cens=cens,
	intensity="gamma",dep="serial",upd="Markov",pbirth=-1))
print(zgmt <- kalsurv(resp,ccov=treat,pinit=1,pdep=0.9,dep="serial",
	psh=1.5,preg=c(4,-0.8),cens=cens,intensity="gamma",upd="Markov"))
print(zgmtb <- kalsurv(resp,ccov=treat,pinit=0.1,pdep=0.5,pbirth=0,
	psh=1,preg=c(4,-0.8),cens=cens,intensity="gamma",dep="serial",
	upd="Markov"))

print(zlnmt <- kalsurv(resp,ccov=treat,pinit=1.71,pdep=0.65,
	psh=2.33,preg=c(4,-0.9),cens=cens,intensity="log normal",
	dep="serial",upd="Markov"))

print(zllmt <- kalsurv(resp,ccov=treat,pinit=1.71,pdep=0.65,
	psh=2.33,preg=c(4,-0.9),cens=cens,intensity="log logistic",
	dep="serial",upd="Markov"))

print(zlcmt <- kalsurv(resp,ccov=treat,pinit=1.71,pdep=0.65,
	psh=2.33,preg=c(4,-0.9),cens=cens,intensity="log Cauchy",
	dep="serial",upd="Markov"))

cn <- rep(1,length(response(resp)))
cn[cumsum(nobs(resp))] <- surv[[2]]
yy <- rep(0,length(response(resp)))
for(i in 1:length(response(resp))){
	if(response(resp)[i]>0)yy[i] <- response(resp)[i]
	else yy[i] <- yy[i-1]}
y <- cbind(yy,cn)
nest <- covind(resp)
tr <- c(rep(0,81),rep(1,173))
birth <- log(sequence(nobs(resp)))

gnlr(y,"exponential",pmu=35)
gnlr(y,"Weibull",pmu=35,pshape=0)
gnlr(y,"gamma",pmu=35,pshape=0)
# note that Burr is not identical to kalsurv with Weibull independence
# when there are ties
gnlr3(y,"Burr",pmu=34,pshape=0,pfam=1)
mu <- function(p) exp(p[1]+p[2]*tr)
gnlr(y,"exponential",pmu=c(3.5,0),mu=mu)
gnlr(y,"Weibull",pmu=c(3.5,0),pshape=0,mu=mu)
gnlr(y,"gamma",pmu=c(3.5,0),pshape=0,mu=mu)
gnlr3(y,"Burr",pmu=c(3.5,0),pshape=0,mu=mu,pfam=1)
mu <- function(p) exp(p[1]+p[2]*birth)
gnlr(y,"exponential",pmu=c(3.5,0),mu=mu)
gnlr(y,"Weibull",pmu=c(4.4,-1),pshape=0,mu=mu)
gnlr(y,"gamma",pmu=c(4.4,-1),pshape=0,mu=mu)
gnlr3(y,"Burr",pmu=c(3.5,0),pshape=0,mu=mu,pfam=1)
mu <- function(p) exp(p[1]+p[2]*tr+p[3]*birth)
gnlr(y,"exponential",pmu=c(3.5,0,0),mu=mu)
gnlr(y,"Weibull",pmu=c(3.5,0,0),pshape=0,mu=mu)
gnlr(y,"gamma",pmu=c(3.5,0,0),pshape=0,mu=mu)
gnlr3(y,"Burr",pmu=c(3.5,0,0),pshape=0,mu=mu,pfam=1)

if(interactive()){
gp <- 2*tr+(sequence(nobs(resp))!=1)
times <- seq(1,185,by=5)
plot(km(yy,censor=cn,group=tr),main="",xlab="Days",
	ylab="Tumour nonrecurrence probability")
postscript("mammary.eps",height=5)
par(mfrow=c(1,2))
plot(km(yy,censor=cn,group=gp),main="",xlab="Days",
	ylab="Tumour nonrecurrence probability")
# kalsurv Weibull
lines(times,exp(zwitb$coef[4])/(exp(zwitb$coef[4])+(times/
	exp(zwitb$coef[1]))^exp(zwitb$coef[5])))
lines(times,exp(zwitb$coef[4])/(exp(zwitb$coef[4])+(times/
	exp(zwitb$coef[1]+zwitb$coef[2]))^exp(zwitb$coef[5])),lty=3)
lines(times,exp(zwitb$coef[4])/(exp(zwitb$coef[4])+(times/
	exp(zwitb$coef[1]+zwitb$coef[3]*log(3)))^exp(zwitb$coef[5])),lty=2)
lines(times,exp(zwitb$coef[4])/(exp(zwitb$coef[4])+(times/
	exp(zwitb$coef[1]+zwitb$coef[2]+zwitb$coef[3]*log(3)))^
	exp(zwitb$coef[5])),lty=4)
legend(95,1,legend=c("First tumour","Retinoid","Control",
	"Subsequent","  tumours","Retenoid","Control"),
	lty=c("0","solid","dotted","0","0","dashed","4413"),bty="n")
plot(times,exp(zwitb$coef[4])*exp(zwitb$coef[5])*(times/
	exp(zwitb$coef[1]))^(exp(zwitb$coef[5])-1)/
	exp(zwitb$coef[1])/(exp(zwitb$coef[4])+
	(times/exp(zwitb$coef[1]))^exp(zwitb$coef[5])),type="l",
	ylim=c(0,0.15),xlab="Days",ylab="Intensity function")
lines(times,exp(zwitb$coef[4])*exp(zwitb$coef[5])*(times/
	exp(zwitb$coef[1]+zwitb$coef[2]))^(exp(zwitb$coef[5])-1)/
	exp(zwitb$coef[1]+zwitb$coef[2])/(exp(zwitb$coef[4])+
	(times/exp(zwitb$coef[1]+zwitb$coef[2]))^exp(zwitb$coef[5])),lty=3)
lines(times,exp(zwitb$coef[4])*exp(zwitb$coef[5])*(times/
	exp(zwitb$coef[1]+zwitb$coef[3]*log(3)))^(exp(zwitb$coef[5])-1)/
	exp(zwitb$coef[1]+zwitb$coef[3]*log(3))/(exp(zwitb$coef[4])+
	(times/exp(zwitb$coef[1]+zwitb$coef[3]*log(3)))^exp(zwitb$coef[5])),
	lty=2)
lines(times,exp(zwitb$coef[4])*exp(zwitb$coef[5])*(times/
	exp(zwitb$coef[1]+zwitb$coef[2]+zwitb$coef[3]*log(3)))^
	(exp(zwitb$coef[5])-1)/exp(zwitb$coef[1]+zwitb$coef[2]+
	zwitb$coef[3]*log(3))/(exp(zwitb$coef[4])+
	(times/exp(zwitb$coef[1]+zwitb$coef[2]+
	zwitb$coef[3]*log(3)))^exp(zwitb$coef[5])),lty=4)
legend(80,0.15,legend=c("First tumour","Retinoid","Control",
	"Subsequent","  tumours","Retenoid","Control"),
	lty=c("0","solid","dotted","0","0","dashed","4413"),bty="n")
}

gnlmm(y,"exponential",pmu=35,delta=cn,nest=nest,psd=0.1,points=7)
gnlmm(y,"Weibull",pmu=35,pshape=0,delta=cn,nest=nest,psd=0.1,points=5)
gnlmm(y,"gamma",pmu=35,pshape=0,delta=cn,nest=nest,psd=0.1,points=5)
mu <- function(p) exp(p[1]+p[2]*tr)
gnlmm(y,"exponential",pmu=c(4.25,-0.5),mu=mu,delta=cn,nest=nest,
	psd=0.1,points=5)
gnlmm(y,"Weibull",pmu=c(4.3,-0.7),pshape=0,mu=mu,delta=cn,nest=nest,
	psd=0.36,points=5)
gnlmm(y,"gamma",pmu=c(4.3,-0.7),pshape=0,mu=mu,delta=cn,nest=nest,
	psd=0.36,points=5)
mu <- function(p) exp(p[1]+p[2]*tr+p[3]*birth)
gnlmm(y,"exponential",pmu=c(4.25,-0.5,-0.7),mu=mu,delta=cn,nest=nest,
	psd=0.1,points=5)
gnlmm(y,"Weibull",pmu=c(4.3,-0.7,-0.7),pshape=0,mu=mu,delta=cn,
	nest=nest,psd=0.36,points=5)
gnlmm(y,"gamma",pmu=c(4.3,-0.7,-0.7),pshape=0,mu=mu,delta=cn,
	nest=nest,psd=0.36,points=5)
