library(event)

times <- read.list("mating.dat",skip=4,nline=1)
tt <- list()
for(i in times)tt <- c(tt,list(c(i[1],diff(i))))
cens <- c(1,1)
species <- c(0,1)

if(interactive()){
postscript("mating.eps",height=5)
par(mfrow=c(1,2))
cprocess(tt,number=F,xlab="Seconds",ylab="Number of matings")
legend(1200,8,legend=c("Ebony flies","Oregon flies"),lty=1:2,bty="n")
plot(km(unlist(tt),group=c(rep(1,27),rep(2,23))),main="",xlab="Seconds",
	ylab="Initiation probability")
lines(seq(1,600,10),1-plnorm(seq(1,600,10),3.95,1.256),lty=3)
legend(300,0.8,legend=c("Ebony flies","Oregon flies","Log normal"),
	lty=1:3,bty="n")
}

y <- c(pp(tt[[1]]),pp(tt[[2]]))
fly <- c(rep(0,2212),rep(1,2970))
ttt <- ttime(unlist(tt),c(rep(1,27),rep(2,23)))/1000
tp <- c(tpast(tt[[1]]),tpast(tt[[2]]))
tp1 <- tp/100
n <- bp(unlist(tt),c(rep(1,27),rep(2,23)))

# exponential
ehr(y,plambda=-5)
ehr(y,plambda=c(-5,0),lambda=~fly)
ehr(y,plambda=c(-4,-0.33,-0.4),lambda=~fly+ttt)
# extreme value
ehr(y,plambda=c(-4.4,-0.2),lambda=~tp1)
ehr(y,plambda=c(-4.2,-0.42,-0.3),lambda=~fly+tp1)
ehr(y,plambda=c(-4.4,-0.001,-0.1),lambda=~tp1+fly:tp1)
ehr(y,plambda=c(-4.2,-0.42,-0.22,0.075),lambda=~fly*tp1)
ehr(y,plambda=c(-4,-0.14,-0.4),lambda=~tp1+ttt)
# Weibull
ehr(y,plambda=c(-4.2,-0.1),lambda=~log(tp))
ehr(y,plambda=c(-4,-0.42,-0.1),lambda=~fly+log(tp))
ehr(y,plambda=c(-3.9,-0.36,-0.009),lambda=~log(tp)+fly:log(tp))
ehr(y,plambda=c(-3.9,-0.36,-0.14,-0.009),lambda=~fly*log(tp))
ehr(y,plambda=c(-4.2,-0.1,-0.4),lambda=~log(tp)+ttt)
# Weibull + birth
ehr(y,plambda=c(-4.2,-0.42,-0.003,0),lambda=~fly+log(tp)+n)
ehr(y,plambda=c(-3.5,-0.6,-0.1,-0.03,-0.37),lambda=~fly+log(tp)+n+ttt)
# other
ehr(y,plambda=c(-4.4,-0.002),lambda=~I(1/tp))
# gamma
lambda <- function(p) hgamma(tp,p[1],p[2])
ehr(y,plambda=c(1,20),lambda=lambda)
lambda <- function(p) hgamma(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(0.7,0,130),lambda=lambda)
lambda <- function(p) hgamma(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(1,100,0),lambda=lambda)
lambda <- function(p) hgamma(tp,p[1],p[2]+p[3]*ttt)
ehr(y,plambda=c(0.9,120,60),lambda=lambda)
# inverse Gauss
lambda <- function(p) hinvgauss(tp,p[1],p[2])
ehr(y,plambda=c(100,0.03),lambda=lambda)
lambda <- function(p) hinvgauss(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(100,30,0.03),lambda=lambda)
lambda <- function(p) hinvgauss(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(100,0.03,-0.01),lambda=lambda)
lambda <- function(p) hinvgauss(tp,p[1]+p[2]*ttt,p[3])
ehr(y,plambda=c(100,5,0.03),lambda=lambda)
# log normal
lambda <- function(p) hlnorm(tp,p[1],p[2])
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*n,p[3])
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(4,1,0),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*ttt,p[3])
ehr(y,plambda=c(3.2,0.73,1.25),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*ttt+p[3]*fly,p[4])
ehr(y,plambda=c(3.2,0.73,0,1.25),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*ttt+p[3]*fly+p[4]*ttt*fly,p[5])
ehr(y,plambda=c(3.3,0.66,-00.07,0,1.16),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1],p[2]+p[3]*ttt)
ehr(y,plambda=c(3.2,1.25,-0.03),lambda=lambda)
# log logistic
lambda <- function(p) hlogis(log(tp),p[1],p[2])-log(tp)
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hlogis(log(tp),p[1]+p[2]*fly,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hlogis(log(tp),p[1],p[2]+p[3]*fly)-log(tp)
ehr(y,plambda=c(4,1,0),lambda=lambda)
lambda <- function(p) hlogis(log(tp),p[1]+p[2]*ttt,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)
# log Cauchy
lambda <- function(p) hcauchy(log(tp),p[1],p[2])-log(tp)
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hcauchy(log(tp),p[1]+p[2]*fly,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hcauchy(log(tp),p[1],p[2]+p[3]*fly)-log(tp)
ehr(y,plambda=c(4,1,0),lambda=lambda)
lambda <- function(p) hcauchy(log(tp),p[1]+p[2]*ttt,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)

if(interactive()){
postscript("mating2.eps",height=5)
par(mfrow=c(1,2))
plot(times[[1]],tt[[1]],xlim=c(0,3000),ylim=c(0,600),xlab="Elapsed time",
	ylab="Time between matings")   
points(times[[2]],tt[[2]],pch=2)   
legend(0,400,legend=c("Ebony flies","Oregon flies"),pch=1:2,bty="n")
plot(seq(1,600,by=5),exp(hlnorm(seq(1,600,by=5),3.3093+0.6311*0.5,1.1627)),
	type="l",ylab="Intensity",xlab="Seconds")
lines(seq(1,600,by=10),exp(hlnorm(seq(1,600,by=10),3.3093+0.6311*1.5,1.1627)),
	lty=2)
lines(seq(1,600,by=10),exp(hlnorm(seq(1,600,by=10),3.3093+0.6311*2.5,1.1627)),
	lty=3)
legend(200,0.02,legend=c("500 seconds","1500 seconds","2500 seconds"),
	lty=1:3,bty="n")
}

tt <- restovec(tt,cens=cens)
print(ze <- kalsurv(tt,pinit=0.1,preg=5,dep="frailty"))
print(zeb <- kalsurv(tt,pinit=0.1,preg=5,pbirth=0,dep="frailty"))
print(zw <- kalsurv(tt,pinit=0.1,preg=5,psh=1,intensity="Weibull",
	dep="frailty"))
print(zwb <- kalsurv(tt,pinit=0.1,preg=5,psh=1,pbirth=0,
	intensity="Weibull",dep="frailty"))

print(zei <- kalsurv(tt,pinit=0.7,preg=5,dep="independence"))
print(zee <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=5,
	dep="serial",upd="event"))
print(zeeb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
	pbirth=0,dep="serial",upd="event"))
print(zem <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=5,
	dep="serial",upd="Markov"))
print(zemb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
	pbirth=0,dep="serial",upd="Markov"))
print(zec <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
	dep="serial",upd="count"))
print(zecb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
	pbirth=0,dep="serial",upd="count"))
#print(zeh <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
#	dep="serial",upd="cumulated"))
print(zek <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,
	dep="serial",upd="kalman"))

print(zeit <- kalsurv(tt,pinit=0.7,dep="independence",
	preg=c(5,1),ccov=species))
print(zeitb <- kalsurv(tt,pinit=0.7,dep="independence",
	pbirth=0,preg=c(5,1),ccov=species))
print(zeet <- kalsurv(tt,pinit=0.7,pdep=0.5,dep="serial",
	upd="event",preg=c(5,1),ccov=species))
print(zeetb <- kalsurv(tt,pinit=0.7,pdep=0.5,
	pbirth=0,dep="serial",upd="event",preg=c(5,1),ccov=species))
print(zemt <- kalsurv(tt,pinit=0.7,pdep=0.5,upd="Markov",
	dep="serial",preg=c(5,1),ccov=species))
print(zemtb <- kalsurv(tt,pinit=0.7,pdep=0.5,
	pbirth=0,dep="serial",upd="Markov",preg=c(5,1),ccov=species))
print(zect <- kalsurv(tt,pinit=0.7,pdep=0.5,upd="count",
	dep="serial",preg=c(5,1),ccov=species))
print(zectb <- kalsurv(tt,pinit=0.7,pdep=0.5,upd="count",
	dep="serial",pbirth=0,preg=c(5,1),ccov=species))
#print(zeht <- kalsurv(tt,pinit=0.7,pdep=0.5,
#	dep="serial",upd="cumulated",preg=c(5,1),ccov=species))
print(zekt <- kalsurv(tt,pinit=0.7,pdep=0.5,upd="kalman",
	dep="serial",preg=c(5,1),ccov=species))

print(zwi <- kalsurv(tt,pinit=0.7,preg=5,psh=1,
	dep="independence",intensity="Weibull"))
print(zwe <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="event",intensity="Weibull"))
print(zweb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	pbirth=0,dep="serial",upd="event",intensity="Weibull"))
print(zwm <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="Markov",intensity="Weibull"))
print(zwmb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	pbirth=0,dep="serial",upd="Markov",intensity="Weibull"))
print(zwc <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="count",intensity="Weibull"))
print(zwh <- kalsurv(tt,pinit=0.6,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="cumulated",intensity="Weibull"))
print(zwk <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="kalman",intensity="Weibull"))

print(zwit <- kalsurv(tt,pinit=0.7,psh=1,
	dep="independence",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwitb <- kalsurv(tt,pinit=0.7,psh=1,pbirth=0,
	dep="independence",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwet <- kalsurv(tt,pinit=0.7,pdep=0.5,psh=1,
	dep="serial",upd="event",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwebt <- kalsurv(tt,pinit=0.7,pdep=0.5,psh=1,dep="serial",
	pbirth=0,upd="event",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwmt <- kalsurv(tt,pinit=0.7,pdep=0.5,psh=1,dep="serial",
	upd="Markov",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwmbt <- kalsurv(tt,pinit=0.7,pdep=0.9,psh=1,dep="serial",
	pbirth=0,upd="Markov",intensity="Weibull",preg=c(4,0.5),ccov=species))
print(zwct <- kalsurv(tt,pinit=0.7,pdep=0.5,psh=1,dep="serial",
	upd="count",intensity="Weibull",preg=c(5,1),ccov=species))
#print(zwht <- kalsurv(tt,pinit=0.7,pdep=0.5,psh=1,dep="serial",
#	upd="cumulated",intensity="Weibull",preg=c(5,1),ccov=species))
print(zwkt <- kalsurv(tt,pinit=0.7,pdep=0.9,psh=1,dep="serial",
	upd="kalman",intensity="Weibull",preg=c(5,1),ccov=species))

print(zgm <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=5,psh=1,
	intensity="gamma",dep="serial",upd="Markov"))
print(zlnm <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=4,psh=1,
	intensity="log normal",dep="serial",upd="Markov"))
print(zllm <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=4,psh=1,
	intensity="log logistic",dep="serial",upd="Markov"))
print(zlcm <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=4,psh=1,
	intensity="log Cauchy",dep="serial",upd="Markov"))

library(gnlm)
y <- response(tt)
cn <- rep(1,length(y))
sp <- species[covind(tt)]
birth <- log(sequence(nobs(tt)))

gnlr(y,"exponential",pmu=100)
gnlr(y,"Weibull",pmu=100,pshape=0)
gnlr(y,"gamma",pmu=100,pshape=0)
mu <- function(p) exp(p[1]+p[2]*sp)
gnlr(y,"exponential",pmu=c(8,-1),mu=mu)
gnlr(y,"Weibull",pmu=c(8,-1),pshape=0,mu=mu)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth)
gnlr(y,"exponential",pmu=c(8,-1,0),mu=mu)
gnlr(y,"Weibull",pmu=c(8,-1,0),pshape=0,mu=mu)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth+p[4]*sp*birth)
gnlr(y,"exponential",pmu=c(8,-1,0,0),mu=mu)
gnlr(y,"Weibull",pmu=c(8,-1,0,0),pshape=0,mu=mu)

mu <- function(p) exp(p[1]+p[2]*sp)
shape <- function(p) p[1]+p[2]*sp
gnlr(y,"Weibull",pmu=c(8,-1),pshape=c(0,0),mu=mu,shape=shape)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth)
shape <- function(p) p[1]+p[2]*sp+p[3]*birth
gnlr(y,"Weibull",pmu=c(8,-1,0),pshape=c(0,0,0),mu=mu,shape=shape)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth+p[4]*sp*birth)
shape <- function(p) p[1]+p[2]*sp+p[3]*birth+p[4]*sp*birth
gnlr(y,"Weibull",pmu=c(8,-1,0,0),pshape=c(0,0,0,0),mu=mu,shape=shape)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth)
shape <- function(p) p[1]+p[2]*birth
gnlr(y,"Weibull",pmu=c(8,-1,0),pshape=c(0,0),mu=mu,shape=shape)
mu <- function(p) exp(p[1]+p[2]*sp+p[3]*birth+p[4]*sp*birth)
gnlr(y,"Weibull",pmu=c(8,-1,0,0),pshape=c(0,0),mu=mu,shape=shape)

times <- unlist(times)/1077.34
mu <- function(p) exp(p[1])
mu2 <- function(p) exp(p[1]+p[2]*sp)
shape1 <- function(p) p[1]*times
shape2 <- function(p) p[1]+p[2]*times
shape3 <- function(p) p[1]+p[2]*sp
shape4 <- function(p) p[1]+p[2]*sp+p[3]*times
shape5 <- function(p) (p[1]+p[2]*sp)*times
shape6 <- function(p) p[1]+(p[2]*sp+p[3])*times

gnlr(y,"Pareto",mu=mu,pmu=4,psh=1.2)
gnlr(y,"Pareto",mu=mu,shape=shape1,pmu=3.7,psh=0.05)
gnlr(y,"Pareto",mu=mu,shape=shape2,pmu=3.7,psh=c(0.02,0.07))
gnlr(y,"Pareto",mu=mu2,pmu=c(4,0),psh=1.2)
gnlr(y,"Pareto",mu=mu2,shape=shape1,pmu=c(3.1,-0.007),psh=0.05)
gnlr(y,"Pareto",mu=mu2,shape=shape2,pmu=c(3,0.5),psh=c(0.1,0.05))
gnlr(y,"Pareto",mu=mu2,shape=shape3,pmu=c(4,0.5),psh=c(0.3,0))
gnlr(y,"Pareto",mu=mu2,shape=shape4,pmu=c(4,0.5),psh=c(0.3,0,0.05))
gnlr(y,"Pareto",mu=mu2,shape=shape5,pmu=c(4,0.4),psh=c(0.05,-0.001))
gnlr(y,"Pareto",mu=mu2,shape=shape6,pmu=c(3.7,0.5),psh=c(0.1,0.05,0))
gnlr(y,"Pareto",mu=mu,shape=shape3,pmu=3.7,psh=c(0.05,0))
gnlr(y,"Pareto",mu=mu,shape=shape5,pmu=3.2,psh=c(0.061,-0.006))
gnlr(y,"Pareto",mu=mu,shape=shape6,pmu=3.7,psh=c(0.1,0.05,0))

# number of unique uncensored observations = 46
length(unique(response(tt)[cn>0]))

# number of ties = 0
sum(response(tt)==0)

# number censored/number = 0/2
length(cens)-sum(cens)
length(cens)
