library(event)

times <- read.list("mating.dat",skip=4,nline=1)
tt <- list()
for(i in times)tt <- c(tt,list(c(i[1],diff(i))))
cens <- c(1,1)
species <- c(0,1)

if(interactive()){
postscript("mating.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(tt,number=F,xlab="Seconds since start",ylab="Number of matings",
	xaxt="n")
axis(1,c(0,1000,2000,3000))
plot(km(unlist(tt),group=c(rep(1,27),rep(2,23))),main="",xlim=c(0,600),
	xaxt="n",xlab="Seconds since previous mating",
	ylab="Initiation probability")
axis(1,c(0,200,400,600))
lines(seq(1,600,10),1-plnorm(seq(1,600,10),3.95,1.256),lty=3)
legend(200,1,legend=c("Ebony flies","Oregon flies","Log normal"),
	lty=1:3,bty="n")
dev.off()
}

y <- c(pp(tt[[1]]),pp(tt[[2]]))
fly <- c(rep(0,2212),rep(1,2970))
ttt <- ttime(unlist(tt),c(rep(1,27),rep(2,23)))/1000
tp <- c(tpast(tt[[1]]),tpast(tt[[2]]))
tp1 <- tp/100
n <- bp(unlist(tt),c(rep(1,27),rep(2,23)))

# exponential
ehr(y,plambda=-5)
ehr(y,plambda=c(-5,0),lambda=~fly)
# Weibull
ehr(y,plambda=c(-4.2,-0.1),lambda=~log(tp))
ehr(y,plambda=c(-4,-0.42,-0.1),lambda=~fly+log(tp))
ehr(y,plambda=c(-3.9,-0.36,-0.009),lambda=~log(tp)+fly:log(tp))
# extreme value
ehr(y,plambda=c(-4.4,-0.2),lambda=~tp1)
ehr(y,plambda=c(-4.2,-0.42,-0.3),lambda=~fly+tp1)
ehr(y,plambda=c(-4.4,-0.001,-0.1),lambda=~tp1+fly:tp1)
# gamma
lambda <- function(p) hgamma(tp,p[1],p[2])
ehr(y,plambda=c(1,20),lambda=lambda)
lambda <- function(p) hgamma(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(1,100,0),lambda=lambda)
lambda <- function(p) hgamma(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(0.7,0,130),lambda=lambda)
# inverse Gauss
lambda <- function(p) hinvgauss(tp,p[1],p[2])
ehr(y,plambda=c(100,0.03),lambda=lambda)
lambda <- function(p) hinvgauss(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(100,30,0.03),lambda=lambda)
lambda <- function(p) hinvgauss(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(100,0.03,-0.01),lambda=lambda)
# log normal
lambda <- function(p) hlnorm(tp,p[1],p[2])
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1]+p[2]*fly,p[3])
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hlnorm(tp,p[1],p[2]+p[3]*fly)
ehr(y,plambda=c(4,1,0),lambda=lambda)
# log logistic
lambda <- function(p) hlogis(log(tp),p[1],p[2])-log(tp)
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hlogis(log(tp),p[1]+p[2]*fly,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hlogis(log(tp),p[1],p[2]+p[3]*fly)-log(tp)
ehr(y,plambda=c(4,1,0),lambda=lambda)
# log Cauchy
lambda <- function(p) hcauchy(log(tp),p[1],p[2])-log(tp)
ehr(y,plambda=c(4,1),lambda=lambda)
lambda <- function(p) hcauchy(log(tp),p[1]+p[2]*fly,p[3])-log(tp)
ehr(y,plambda=c(4,0,1),lambda=lambda)
lambda <- function(p) hcauchy(log(tp),p[1],p[2]+p[3]*fly)-log(tp)
ehr(y,plambda=c(4,1,0),lambda=lambda)

lambda <- function(p) hlnorm(tp,p[1]+p[2]*ttt,p[3])
ehr(y,plambda=c(3.2,0.73,1.25),lambda=lambda)

if(interactive()){
postscript("mating2.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(times[[1]],tt[[1]],xlim=c(0,3000),ylim=c(0,600),xaxt="n",yaxt="n",
	xlab="Seconds since start",ylab="Seconds since previous mating")
axis(1,c(0,1000,2000,3000))
axis(2,c(0,200,400,600))
points(times[[2]],tt[[2]],pch=2)   
legend(0,400,legend=c("Ebony flies","Oregon flies"),pch=1:2,bty="n")
plot(seq(1,600,by=5),exp(hlnorm(seq(1,600,by=5),3.3093+0.6311*0.5,1.1627)),
	type="l",xaxt="n",ylab="Intensity",
	xlab="Seconds since previous mating")
axis(1,c(0,200,400,600))
lines(seq(1,600,by=10),exp(hlnorm(seq(1,600,by=10),3.3093+0.6311*1.5,1.1627)),
	lty=2)
lines(seq(1,600,by=10),exp(hlnorm(seq(1,600,by=10),3.3093+0.6311*2.5,1.1627)),
	lty=3)
legend(100,0.02,legend=c("500 seconds since start","1500 seconds",
	"2500 seconds"),lty=1:3,bty="n")
dev.off()
}
