library(event)

data <- read.table("myeloid.dat",skip=5,head=T)
attach(data)
id <- tv <- times <- censor <- state <- ada <- NULL
for(i in 1:55){
	ll <- sum(Id==i)
	times <- c(times,diff(Times[Id==i]))
	tv <- c(tv,c(0,diff(Times[Id==i])))
	cen <- rep(0,ll-1)
	st <- 1
	ada <- c(ada,c(ADA[Id==i][1],ADA[Id==i][1:(ll-1)]))
	for(j in 2:ll){
		state <- c(state,st)
		if(State[Id==i][j-1]!=State[Id==i][j]){
			cen[j-1] <- 1
			st <- st+1}}
	censor <- c(censor,cen)
	id <- c(id,rep(i,ll-1))}

y <- pp(times,cens=censor)
pst <- tvcov(times,state,times)-1
pada <- tvcov(times,ada,tv)
tp <- tpast(times)

mean(ADA[State==1])
mean(ADA[State==2])

# exponential
ehr(y,plambda=-5)
ehr(y,plambda=c(-6.2,1),lambda=~pst)
ehr(y,plambda=c(-6.2,0),lambda=~pada)
ehr(y,plambda=c(-6.7,0.9,0.03),lambda=~pst+pada)
ehr(y,plambda=c(-6.7,1,0.02,0),lambda=~pst*pada)
# Weibull
ehr(y,plambda=c(-5,0),lambda=~log(tp))
ehr(y,plambda=c(-5.8,-0.14,1),lambda=~log(tp)+pst)
ehr(y,plambda=c(-5.8,-0.14,0),lambda=~log(tp)+pada)
ehr(y,plambda=c(-6.65,-0.03,1,0.03),lambda=~log(tp)+pst+pada)
ehr(y,plambda=c(-6.65,-0.03,1,0.03,0.001),lambda=~log(tp)+pst*pada)
# different Weibull
ehr(y,plambda=c(-5.7,-0.17,0.16,0.35),lambda=~log(tp)*pst)
ehr(y,plambda=c(-5.8,-0.126,0.16,0.03,0.35),lambda=~log(tp)*pst+pada)
ehr(y,plambda=c(-5.83,-0.23,0.16,0.027,0.34,0),lambda=~log(tp)*pst+pada*pst)
ehr(y,plambda=c(-5.83,-0.23,0.023,0.002),lambda=~log(tp)*pada)
ehr(y,plambda=c(-5.83,-0.23,0.16,0.027,0.34,0),lambda=~log(tp)*(pst+pada))
# gamma
lambda <- function(p) {
       p <- exp(p)
       log(dgamma(tp,p[1],p[2]))-log(1-pgamma(tp,p[1],p[2]))}
ehr(y,plambda=c(log(0.8),log(890)),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pada)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(-0.24,6.8,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(-0.24,6.8,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst+p[4]*pada)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(-0.1,6.85,-1,-0.03),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst+p[4]*pada+p[5]*pst*pada)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(-0.1,6.85,-1,-0.03,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1]+p[2]*pada)
	p2 <- exp(p[3]+p[4]*pada)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(-0.1,0,6.85,-0.03),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1]+p[2]*pada+p[3]*pst)
	p2 <- exp(p[4]+p[5]*pada+p[6]*pst)
	log(dgamma(tp,p1,p2))-log(1-pgamma(tp,p1,p2))}
ehr(y,plambda=c(1,-0.087,1.25,5.8,0.04,-2.84),lambda=lambda)
# log normal
lambda <- function(p) log(dlnorm(tp,p[1],p[2]))-log(1-plnorm(tp,p[1],p[2]))
ehr(y,plambda=c(7,2),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada,p[3]))-
	log(1-plnorm(tp,p[1]+p[2]*pada,p[3]))
ehr(y,plambda=c(6.7,-0.044,1.8),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pst,p[3]))-
	log(1-plnorm(tp,p[1]+p[2]*pst,p[3]))
ehr(y,plambda=c(6.7,-0.044,1.8),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]))-
	log(1-plnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]))
ehr(y,plambda=c(6.5,-0.044,-1,2.1),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada+p[3]*pst+p[4]*pada*pst,
	p[5]))-log(1-plnorm(tp,p[1]+p[2]*pada+p[3]*pst+p[4]*pada*pst,p[5]))
ehr(y,plambda=c(6.74,-0.044,-0.96,0,1.76),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada,p[3]+p[4]*pada))-
	log(1-plnorm(tp,p[1]+p[2]*pada,p[3]+p[4]*pada))
ehr(y,plambda=c(6.7,-0.046,1.8,0),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada))-
	log(1-plnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada))
ehr(y,plambda=c(6.7,-0.044,0,1.8,0.015),lambda=lambda)
lambda <- function(p) log(dlnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada+
	p[6]*pst))-
	log(1-plnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada+p[6]*pst))
ehr(y,plambda=c(7.28,-0.068,-1.89,1.14,0.063,-1.275),lambda=lambda)
# log logistic
lambda <- function(p) log(dlogis(log(tp),p[1],p[2])/tp)-
	log(1-plogis(log(tp),p[1],p[2]))
ehr(y,plambda=c(7,2),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pada,p[3])/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pada,p[3]))
ehr(y,plambda=c(6.26,0,1.1),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pst,p[3])/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pst,p[3]))
ehr(y,plambda=c(6.26,0,1.1),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4])/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4]))
ehr(y,plambda=c(6.26,-1.1,-0.05,1.1),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,
	p[5])/tp)-log(1-plogis(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,
	p[5]))
ehr(y,plambda=c(6.26,-0.93,-0.05,0,1),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada)/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada))
ehr(y,plambda=c(7.15,-0.097,0.44,0.04),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pada+p[3]*pst,p[4]+
	p[5]*pada)/tp)-log(1-plogis(log(tp),p[1]+p[2]*pada+p[3]*pst,
	p[4]+p[5]*pada))
ehr(y,plambda=c(7.13,-0.081,-1.56,0.55,0.031),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada+
	p[5]*pst)/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada+p[5]*pst))
ehr(y,plambda=c(7.4,-0.11,0.45,0.04,0),lambda=lambda)
lambda <- function(p) log(dlogis(log(tp),p[1]+p[2]*pada+p[3]*pst,p[4]+
	p[5]*pada+p[6]*pst)/tp)-
	log(1-plogis(log(tp),p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada+p[6]*pst))
ehr(y,plambda=c(7.315,-0.09,-1.4,0.45,0.04,-0.61),lambda=lambda)
# log Cauchy
lambda <- function(p) log(dcauchy(log(tp),p[1],p[2])/tp)-
	log(1-pcauchy(log(tp),p[1],p[2]))
ehr(y,plambda=c(6,1),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pada,p[3])/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pada,p[3]))
ehr(y,plambda=c(5.9,0,0.9),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pst,p[3])/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pst,p[3]))
ehr(y,plambda=c(5.9,0,0.9),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4])/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4]))
ehr(y,plambda=c(6.94,-1.04,-0.08,1),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada+
	p[4]*pst*pada,p[5])/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,p[5]))
ehr(y,plambda=c(8.58,-1.24,-0.18,0,1),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada)/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada))
ehr(y,plambda=c(7.6,-0.15,-0.21,0.08),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pada+p[3]*pst,
	p[4]+p[5]*pada)/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada))
ehr(y,plambda=c(7.48,-0.14,-0.68,-0.21,0.086),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada+
	p[5]*pst)/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pada,p[3]+p[4]*pada+p[5]*pst))
ehr(y,plambda=c(7.6,-0.15,-0.21,0.08,0),lambda=lambda)
lambda <- function(p) log(dcauchy(log(tp),p[1]+p[2]*pada+p[3]*pst,
	p[4]+p[5]*pada+p[6]*pst)/tp)-
	log(1-pcauchy(log(tp),p[1]+p[2]*pada+p[3]*pst,p[4]+p[5]*pada+p[6]*pst))
ehr(y,plambda=c(7.49,-0.14,-0.73,-0.16,0.07,-0.14),lambda=lambda)

if(interactive()){
times <- censor <- state <- NULL
for(i in 1:55){
	st <- State[Id==i]
	st1 <- st[1]
	tm <- Times[Id==i]
	tm1 <- tm[1]
	for(j in 2:length(tm)){
		if(st1!=st[j]){
			state <- c(state,st1)
			times <- c(times,tm[j]-tm1)
			censor <- c(censor,1)
			st1 <- st[j]
			tm1 <- tm[j]}}
	if(st1!=3&&tm[j]-tm1>0){
		times <- c(times,tm[j]-tm1)
		state <- c(state,st1)
		censor <- c(censor,0)}}
postscript("myeloid.eps",height=5)
par(mfrow=c(1,2))
plot(km(times=times,censor=censor,group=state),main="",xlab="Days",
	ylab="State duration probability",xlim=c(0,1050))
tt <- seq(1,1050,by=10)
lines(tt,1-plogis(log(tt),7.15-0.097*8.52,0.44+0.0393*8.52))
tt <- seq(1,440,by=10)
lines(tt,1-plogis(log(tt),7.15-0.097*21.22,0.44+0.0393*21.22),lty=2)
tt <- seq(1,1050,by=10)
lines(tt,1-pcauchy(log(tt),7.6-0.152*8.52,-0.21+0.07955*8.52),lty="4212")
tt <- c(0.1,seq(1,440,by=10))
lines(tt,1-pcauchy(log(tt),7.6-0.152*21.22,-0.21+0.07955*21.22),lty=3)
tt <- seq(1,1050,by=10)
plot(tt,dlogis(log(tt),7.15-0.097*8.52,0.44+0.0393*8.52)/
	(1-plogis(log(tt),7.15-0.097*8.52,0.44+0.0393*8.52))/tt,
	type="l",ylab="Intensity",xlab="Days",ylim=c(0,0.015),xlim=c(0,1050))
tt <- seq(1,440,by=10)
lines(tt,dlogis(log(tt),7.15-0.097*21.22,0.44+0.0393*21.22)/
	(1-plogis(log(tt),7.15-0.097*21.22,0.44+0.0393*21.22))/tt,lty=2)
tt <- seq(1,1050,by=10)
lines(tt,dcauchy(log(tt),7.6-0.152*8.52,-0.21+0.07955*8.52)/
	(1-pcauchy(log(tt),7.6-0.152*8.52,-0.21+0.07955*8.52))/tt,lty="4212")
tt <- c(0.1,seq(1,440,by=10))
lines(tt,dcauchy(log(tt),7.6-0.152*21.22,-0.21+0.07955*21.22)/
	(1-pcauchy(log(tt),7.6-0.152*21.22,-0.21+0.07955*21.22))/tt,lty=3)
}
