library(event)
library(gnlm)

data <- read.table("st.dat",skip=2,head=T)
attach(data)

tr <- rep(c(tr1,tr2,tr3),2)
tot <- c(tot1,tot2,tot3)
lp <- c(lp1,lp2,lp3)
mp <- c(mp1,mp2,mp3)
st <- c(st1,st2,st3)
lpc <- c(lpc1,lpc2,lpc3)
mpc <- c(mpc1,mpc2,mpc3)
mp <- mp-lp
stt <- tot-st
mp0 <- mp0-lp0
res <- c(rep(1,45),rep(2,45))
p <- rep(c(rep(1,15),rep(2,15),rep(3,15)),2)
tt <- c(lp,mp)
cens <- c(lpc,mpc)
id <- rep(id,6)
gr <- rep(gr,6)
lp0 <- rep(lp0,6)
mp0 <- rep(mp0,6)
co <- rep(c(tr0,tr1,tr2),2)+1
std1 <- ifelse(lp<st,lp,st)
std2 <- lp-std1
std3 <- ifelse(lp>st,0,st-lp)
std4 <- mp-std3
i <- as.integer(gl(45,2,90))
j <- as.integer(gl(2,1,90))
ii <- as.integer(gl(2,1,180))
stda <- stdb <- rep(0,90)
stda[seq(1,90,by=2)] <- std1
stda[seq(2,90,by=2)] <- std2
stdb[seq(1,90,by=2)] <- std3
stdb[seq(2,90,by=2)] <- std4
std <- c(stda,stdb)
rm(std1,std2,std3,std4,stda,stdb)

cens <- cens[tt>0]
id <- id[tt>0]
idf <- as.factor(id)
gr <- gr[tt>0]
tr <- tr[tt>0]
trf <- as.factor(tr)
ii <- ii[std>0]
std <- std[std>0]
p <- p[tt>0]
pf <- as.factor(p)
res <- res[tt>0]-1
co <- co[tt>0]
tt <- tt[tt>0]

event <- pp(tt,cens)
ident <- as.factor(ident(tt,id))
time <- tpast(tt)
group <- as.factor(tvcov(tt,gr,tt))
treat <- as.factor(tvcov(tt,tr,tt))
stdep <- tvcov(std,ii,std)
per <- as.factor(tvcov(tt,p,tt))
resp <- tvcov(tt,res,tt)
carry <- as.factor(tvcov(tt,co,tt))
ltime <- log(time)

ehr(event,lambda=~ident+ltime+resp+treat+stdep+resp*per,
	plambda=c(-16.2,-0.75,-1.2,-1.24,-1.1,-1,0.53,-6,-2.2,-3.3,2.9,-4.8,
	-0.63,1.96,0.34,4,5.2,-1.4,-1.9,1.53,-0.5,1.06,1.23,-2.59))

ehr(event,plambda=c(-6.6,rep(0,22)),lambda=~ident+treat+stdep+resp*per,
	iter=200)
ehr(event,plambda=c(-6.6,rep(0,21)),lambda=~ident+ltime+stdep+resp*per,
	iter=200)
ehr(event,plambda=c(-6.6,rep(0,22)),lambda=~ident+ltime+treat+resp*per,
	iter=200)
carry3 <- as.factor(ifelse(carry==4,1,carry))
ehr(event,plambda=c(-16.8,rep(0,25)),
	lambda=~ident+ltime+treat+stdep+resp*per+carry3,iter=200)
ehr(event,plambda=c(-6.6,rep(0,24)),
	lambda=~ident+ltime*resp+treat+stdep+resp*per,iter=200)
ehr(event,plambda=c(-6.6,rep(0,25)),
	lambda=~ident+ltime+resp*treat+stdep+resp*per,iter=200)
ehr(event,plambda=c(-6.6,rep(0,24)),
	lambda=~ident+ltime+treat+resp*stdep+resp*per,iter=200)
ehr(event,plambda=c(-6.6,rep(0,27)),
	lambda=~ident+ltime+treat+stdep+resp*(per+carry3),iter=200)

print(zc <- gnlr(cbind(log(tt),cens),"Cauchy",mu=~idf+res+trf+res*pf,
	pmu=c(3.4,rep(0,21)),psh=2.9,delta=1/tt))
lambda <- function(p,linear) log(dcauchy(log(time),linear,p[1])/time)-
	log(1-pcauchy(log(time),linear,p[1]))
print(zc <- ehr(event,lambda=lambda,linear=~ident+resp+treat+stdep+resp*per,
	plambda=c(0.06,zc$coef[1:18],-0.32,zc$coef[19:22])))

if(interactive()){
postscript("st.eps")
par(mfrow=c(2,2),font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(km(tt[tr==1&res==0],cens=cens[tr==1&res==0]),xlim=c(0,80),xaxt="n",
	main="Mild pain",ylab="Probability of no pain",xlab="")
axis(1,c(0,20,40,60,80))
plot(km(tt[tr==2&res==0],cens=cens[tr==2&res==0]),add=T,lty=2)
plot(km(tt[tr==3&res==0],cens=cens[tr==3&res==0]),add=T,lty=3)
lines(1:72,1-pcauchy(log(1:72),3.9-0.33,0.061))
lines(1:72,1-pcauchy(log(1:72),3.9-0.33+0.227,0.061),lty=2)
lines(1:72,1-pcauchy(log(1:72),3.9-0.33+0.361,0.061),lty=3)
plot(km(tt[tr==1&res==1],cens=cens[tr==1&res==1]),xlim=c(0,80),xaxt="n",
	main="Moderate pain",ylab="",xlab="")
axis(1,c(0,20,40,60,80))
plot(km(tt[tr==2&res==1],cens=cens[tr==2&res==1]),add=T,lty=2)
plot(km(tt[tr==3&res==1],cens=cens[tr==3&res==1]),add=T,lty=3)
lines(1:72,1-pcauchy(log(1:72),3.9-0.33-0.968,0.061))
lines(1:72,1-pcauchy(log(1:72),3.9-0.33+0.227-0.968,0.061),lty=2)
lines(1:72,1-pcauchy(log(1:72),3.9-0.33+0.361-0.968,0.061),lty=3)
legend(40,0.9,c("A","B","C"),lty=1:3,bty="n")
plot(1:72,dcauchy(log(1:72),3.9-0.33,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33,0.061))/(1:72),type="l",xlim=c(0,80),ylim=c(0,0.9),xaxt="n",
	ylab="Risk of pain",xlab="Tens of seconds")
axis(1,c(0,20,40,60,80))
lines(1:72,dcauchy(log(1:72),3.9-0.33+0.227,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33+0.227,0.061))/(1:72),lty=2)
lines(1:72,dcauchy(log(1:72),3.9-0.33+0.361,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33+0.361,0.061))/(1:72),lty=3)
plot(1:72,dcauchy(log(1:72),3.9-0.33-0.968,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33-0.968,0.061))/(1:72),type="l",xlim=c(0,80),ylim=c(0,0.9),
	xaxt="n",ylab="",xlab="Tens of seconds")
axis(1,c(0,20,40,60,80))
lines(1:72,dcauchy(log(1:72),3.9-0.33+0.227-0.968,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33+0.227-0.968,0.061))/(1:72),lty=2)
lines(1:72,dcauchy(log(1:72),3.9-0.33+0.361-0.968,0.061)/(1-pcauchy(log(1:72),
	3.9-0.33+0.361-0.968,0.061))/(1:72),lty=3)
dev.off()
}
